############################
#### {{ ansible_managed }}
############################
# /etc/haproxy/haproxy.cfg
#---------------------------------------------------------------------
# Global settings
#---------------------------------------------------------------------
global
    log /dev/log local0 info
    log /dev/log local1 info
    daemon
    user haproxy
    group haproxy

    # Default SSL material locations
    ca-base /etc/ssl/certs
    crt-base /etc/ssl/private
#---------------------------------------------------------------------
# common defaults that all the 'listen' and 'backend' sections will
# use if not designated in their block
#---------------------------------------------------------------------

defaults
    mode                    http
    log                     global
    option                  httplog
    option                  dontlognull
    option http-server-close
    # option forwardfor       except 127.0.0.0/8
    option                  redispatch
    retries                 1
    timeout http-request    10s
    timeout queue           20s
    timeout connect         5s
    timeout client          20s
    timeout server          20s
    timeout tunnel	    60s
    timeout http-keep-alive 10s
    timeout check           10s

#---------------------------------------------------------------------
# http in default frontend
#---------------------------------------------------------------------

frontend default_http_backend
    bind *:80
    mode tcp
    option tcplog
    default_backend default_http_backend

    # option forwardfor

backend default_http_backend
    mode tcp
    option tcp-check

    # balance ( roundrobin or leastconn )
    balance leastconn

{% for item in groups['k8s_workers'] %}
{% set short_name = item.split('.') %}
    server {{ short_name[0] }} {{ hostvars[item]['ansible_host'] }}:30802 check
{% endfor %}


#---------------------------------------------------------------------
# https in default frontend
#---------------------------------------------------------------------

frontend default_https_backend
    bind *:443
    mode tcp
    option tcplog
    default_backend default_https_backend

    # option forwardfor

backend default_https_backend
    mode tcp
    option tcp-check
    timeout server 3600s
    timeout server-fin 3600s
    timeout tunnel 3600s

    # balance ( roundrobin or leastconn )
    balance leastconn
    default-server inter 10s downinter 5s rise 2 fall 2 slowstart 60s maxconn 250 maxqueue 256 weight 100

{% for item in groups['k8s_workers'] %}
{% set short_name = item.split('.') %}
    server {{ short_name[0] }} {{ hostvars[item]['ansible_host'] }}:30688 check
{% endfor %}

#---------------------------------------------------------------------
